//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
#include <sharemem.hpp>
#include <filectrl.hpp>

#include "qspgpver.h"
#include "pgprecipdlgs.h"
#include "pgpcache.h"
#include "pgppath.h"
#include "pgpbuffers.h"
#include "PgpPassEx.h"
#include "PgpFiles.h"
#include "PgpSdk.h"
#include "PgpSdk6.h"
#include "PgpSdk8.h"
#include "PgpMsg.h"
#include "global.h"
#include "fileman.h"
#include "headman.h"
#include "pgpdlgs.h"
#include "MixDlgs.h"
#include "pgpdb.h"
#include "view.h"

//#define curdir ExtractFilePath(Application->ExeName).c_str()
// REMEMBER: ActMainForm is the actual QS main form and must be used
// as, ActMainForm->Handle, in all MsgBoxes

USERES("QSpgp\QSpgp.res");
USEUNIT("QSpgp\PgpSdk6.cpp");
USEFORM("QSpgp\PgpRecipDlgs.cpp", PgpRecipForm);
USEFORM("QSpgp\PgpPassEx.cpp", PgpPassForm);
USEUNIT("QSpgp\PgpCache.cpp");
USEUNIT("QSpgp\PgpPath.cpp");
USEUNIT("QSpgp\QSpgpVer.cpp");
USEUNIT("QSpgp\PgpMsg.cpp");
USEUNIT("QSpgp\pgpdb.cpp");
USEFORM("QSpgp\HelpDlgs.cpp", HelpDlg);
USEFORM("QSpgp\WipeDlgs.cpp", WipeDlg);
USEFORM("QSpgp\View.cpp", ViewDlg);
USEUNIT("QSpgp\Mixmaster.cpp");
USEUNIT("QSpgp\TBuffer.cpp");
USEUNIT("QSpgp\PGPbuffers.cpp");
USEUNIT("QSpgp\FileMan.cpp");
USEUNIT("QSpgp\HeadMan.cpp");
USEUNIT("QSpgp\fmxutils.cpp");
USEUNIT("QSpgp\Global.cpp");
USEUNIT("QSpgp\pgpfiles.cpp");
USEUNIT("QSpgp\pgp.cpp");
USEFORM("QSpgp\pgpkeyexpdlgs.cpp", PgpKeyExpDlg);
USEFORM("QSpgp\pgpkeyimpdlgs.cpp", PgpKeyImpDlg);
USELIB("QSpgp\Zlib.lib");
USEFORM("QSpgp\PgpDlgs.cpp", PgpDlg);
USEUNIT("QSpgp\PgpSdk.cpp");
USEOBJ("QSpgp\PgpSdk8Calls.obj");
USEOBJ("QSpgp\PgpSdk8.obj");  // pgpsdk8.cpp is not included--just .obj for compatibility
//---------------------------------------------------------------------------
#define DLLEXPORT __declspec(dllexport)
extern "C" {
DLLEXPORT void __fastcall PgpInit(HINSTANCE HMixLib, HINSTANCE HSSLLib,
   TForm *MainForm, HWND AppHandle);

DLLEXPORT void  __fastcall PgpShutDown();
DLLEXPORT char* __fastcall GetPgpLibVersion();
DLLEXPORT char* __fastcall GetPgpLibName();
DLLEXPORT bool  __fastcall HasPgpSdk();

DLLEXPORT char* __fastcall PgpPubringPkr();
DLLEXPORT char* __fastcall PgpSecringSkr();
DLLEXPORT bool  __fastcall PgpUpdateQSKeyrings();
DLLEXPORT bool  __fastcall PgpCheckPGP6NeedsUpdate();
DLLEXPORT bool  __fastcall PgpIsClearSigned(char *Message);
DLLEXPORT char* __fastcall PgpSignMessage(char *Message);
DLLEXPORT char* __fastcall PgpEncryptMessage(char *Message);
DLLEXPORT char* __fastcall PgpEncryptSignMessage(char *Message);
DLLEXPORT char* __fastcall PgpDecryptVerifyMessage(char *Message, bool ForceDialog);
DLLEXPORT char* __fastcall PgpVerifyMessage(char *Message);
DLLEXPORT bool  __fastcall PgpIsConventional(char *Message);
DLLEXPORT bool  __fastcall PgpGetEncryptList(TForm *Owner, TStrings *Recips, bool CanConv);
DLLEXPORT void  __fastcall PgpClearPassphraseCache();
DLLEXPORT char* __fastcall PgpPath();

// for PgpKeyWin MDI in pgp dll--Init is being called but probably won't be used
DLLEXPORT void  __fastcall PgpInitAppAndScrn(TApplication *MainApp, TScreen *MainScrn);
DLLEXPORT void  __fastcall PgpOpenPersonalKeyring();
DLLEXPORT bool  __fastcall PgpImportKeys(TForm *Owner, TPGPbuffer *ImpKeys, char* ImportDir);
DLLEXPORT bool  __fastcall PgpExportKeys(TForm *Owner, TPGPbuffer *PublicKeys,
   TPGPbuffer *SecretKeys, char *SelectedKeyId, char *ExportDir);
}

bool __fastcall HasSdk();
TPGPsdk* __fastcall PGPInitV6();
TPGPsdk* __fastcall PGPInitV8(TForm *Owner, const AnsiString &pubring,
   const AnsiString &secring, const AnsiString &remring);

typedef TPGPsdk* __fastcall (*PGPINITV8)(TForm*, const AnsiString&, const AnsiString&,
   const AnsiString&);
//typedef void __fastcall (*PGPSHUTDOWNV8)();
//---------------------------------------------------------------------------
//TApplication *orgApp = NULL;
//TScreen *orgScr = NULL;
char *retbuf = NULL;
//---------------------------------------------------------------------------

int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
  return 1;
}
//---------------------------------------------------------------------------

void  __fastcall PgpInit(HINSTANCE HMixLib, HINSTANCE HSSLLib, TForm *MainForm,
   HWND AppHandle)
{
   SetCurrentDirectory(ExtractFilePath(Application->ExeName).c_str());
   Passphrase = new TPassphrase(NULL);
   hMixLib = HMixLib; hSSLLib = HSSLLib;
   Application->Handle = AppHandle;
   ActMainForm = MainForm;

   PGPsdk = PGPInitV8(MainForm, PgpPublicRing(), PgpSecretRing(), PgpRemailRing());
   if (PGPsdk == NULL)
      PGPsdk = PGPInitV6();

   //orgApp = Application;
   //orgScr = Screen;
}
//---------------------------------------------------------------------------

void __fastcall PgpShutDown()
{
   //if (orgApp) Application = orgApp;
   //if (orgScr) Screen = orgScr;
   delete Passphrase;
   delete PGPsdk;
}
//---------------------------------------------------------------------------

char* __fastcall GetPgpLibVersion()
{
   return ReleaseVer.c_str();
}
//---------------------------------------------------------------------------

char* __fastcall GetPgpLibName()
{
   return AppName.c_str();
}
//---------------------------------------------------------------------------

bool __fastcall HasPgpSdk()
{
   return PGPsdk != NULL;
}
//---------------------------------------------------------------------------

bool __fastcall HasSdk()
{
   return PGPsdk != NULL;
}

//---------------------------------------------------------------------------
// PGP6
//---------------------------------------------------------------------------

TPGPsdk* __fastcall PGPInitV6()
{
   hPgpSdk = LoadLibrary("pgp_sdk.dll");
   if ( hPgpSdk)
   {
      PGPsdk = new TPGPsdk6(ActMainForm, hPgpSdk);
      if (!PGPsdk->InitSuccess)
      {
         FreeLibrary(hPgpSdk);
         hPgpSdk = NULL;
         delete PGPsdk;
         PGPsdk = NULL;
      }
   }
   return PGPsdk;
}

//---------------------------------------------------------------------------
// PGP8
//---------------------------------------------------------------------------

TPGPsdk* __fastcall PGPInitV8(TForm *Owner, const AnsiString &pubring,
   const AnsiString &secring, const AnsiString &remring)
{
   PGPsdk = new TPGPsdk8(Owner, pubring, secring, remring);
   if (!PGPsdk->InitSuccess)
   {
      delete PGPsdk;
      PGPsdk = NULL;
   }
   return PGPsdk;
}

//---------------------------------------------------------------------------
// PGP Plugin
//---------------------------------------------------------------------------

void  __fastcall PgpInitAppAndScrn(TApplication *MainApp, TScreen *MainScr)
{
   //Application = MainApp;
   //Screen = MainScr;
}
//---------------------------------------------------------------------------
void  __fastcall PgpClearPassphraseCache()
{
   Passphrase->Clear();
   MsgBoxTsk("Passphrase cache cleared!","Information",MB_OK);
}
//---------------------------------------------------------------------------
bool __fastcall CutMessageAtCutmarks(TStrings *msg)
{
   bool cut = false;
   if (msg->Text.Pos("\r\n"+CutMarks+"\r\n"))
   {
      while (msg->Count)
      {
         AnsiString line = msg->Strings[msg->Count-1];
         msg->Delete(msg->Count-1);
         if (line.TrimRight()==CutMarks) break;
      }
      cut = true;
   }
   while (msg->Count && msg->Strings[msg->Count-1].IsEmpty())
      msg->Delete(msg->Count-1);
   return cut;
}
//---------------------------------------------------------------------------
bool __fastcall InType1(AnsiString &remailer, TStrings *type1)
{
   bool ok = false;
   for (int i=0; i<type1->Count; i++)
   {
      if (type1->Strings[i]==remailer)// || type->Strings[i]=="#"+remailer)
      {
         ok = true;
         break;
      }
   }
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall GenShortList(TStrings *list)
{
   AnsiString line,tmp;
   TStringList *lines = new TStringList();
   for (int i=0; i<list->Count; i++)
   {
      tmp = list->Strings[i];
      if (tmp.Pos("$remailer{")!=1) continue;
      line = GetParam(1,tmp,"<"); line = GetParam(0,line,">");
      line += "="+GetParam(1,tmp,"\"");
      lines->Add(line);
   }
   list->Text = lines->Text;
   delete lines;
   return list->Count>0;
}
//---------------------------------------------------------------------------
bool __fastcall CpkGenShortList(TStrings *list)
{
   TStringList *clist = new TStringList();
   TStringList *alist = new TStringList();
   clist->Duplicates = dupIgnore; clist->Sorted = true;
   GetAppData(alist,CpunkShorts); clist->AddStrings(alist);
   int c=clist->Count;

   if (FileExists(clisttxt)) alist->LoadFromFile(clisttxt);
   GenShortList(alist); clist->AddStrings(alist);

   if (FileExists(clisttmp)) alist->LoadFromFile(clisttmp);
   GenShortList(alist); clist->AddStrings(alist);

   // check for new entries to save
   if (c<clist->Count) PutAppData(CpunkShorts,clist);

   list->AddStrings(clist);
   delete alist;
   delete clist;
   return list->Count>0;
}
//---------------------------------------------------------------------------
/*char* __fastcall PgpArmorBlockToArmorKeysCpk(char *BigBlock)
{
   TStringList *newlist = new TStringList();
   newlist->Duplicates=dupIgnore; newlist->Sorted = true;

   TStringList *cpklist = new TStringList();
   CpkGenShortList(cpklist);

   TStringList *bigblock = new TStringList(); bigblock->SetText(BigBlock);
   if (retbuf) delete retbuf; retbuf = NULL;

   TPgpDB *pgpdb = new TPgpDB(bigblock);
   delete bigblock;

   TStringList *keyblocks = new TStringList();
   pgpdb->SaveToStringsCpk(keyblocks,cpklist);
   if ((retbuf=new char[keyblocks->Text.Length()+1])!=NULL)
      strcpy(retbuf,keyblocks->Text.c_str());
   delete keyblocks;

   delete cpklist;
   delete pgpdb;
   return retbuf;
}*/
//---------------------------------------------------------------------------
bool __fastcall GetEncryptKeyidsFromPgpHdr(TStrings *msg, TStrings *keyids,
   AnsiString &keyiderr)
{
   keyids->Clear();
   TPGPbuffer *key = new TPGPbuffer();
   TPGPbuffer *pubs = new TPGPbuffer(PgpPublicRing(),NO_DISABLED);
   TPGPbuffer *cpks = new TPGPbuffer(PgpRemailRing(),NO_DISABLED);

   keyiderr = "";
   TStringList *cmds = new TStringList();
   THeaderManager *hm = new THeaderManager(msg);
   AnsiString id,ids,cmd,keyid,hdr = hm->GetDat(PgpHdr);
   if (hdr.IsEmpty()) hm->GetDat(PgpButtonsHdr);
   int i=0; while((cmd=GetToken(i++,hdr,";"))!="")
      cmds->Add(cmd.Trim());
   ids = cmds->Values["encrypt"];
   i=0; while((id=GetToken(i++,ids,","))!="")
      keyids->Add(id);
   delete cmds;
   delete hm;

   for (int i=0; i<keyids->Count; i++)
   {
      keyid = keyids->Strings[i].SubString(1,10);
      if (pubs->get(keyid,key) || cpks->get(keyid,key)) keyids->Strings[i] = keyid+" "+key->firstuid;
      else
      {
         keyiderr = keyid;
         break;
      }
   }

   delete cpks;
   delete pubs;
   delete key;
   return keyiderr.IsEmpty() && keyids->Count>0;
}
//---------------------------------------------------------------------------
bool __fastcall GetSignKeyidFromPgpHdr(TStrings *msg, AnsiString &keyid,
   AnsiString &passphrase)
{
   TStringList *cmds = new TStringList();
   THeaderManager *hm = new THeaderManager(msg);
   AnsiString id,ids,cmd,hdr = hm->GetDat(PgpHdr);
   if (hdr.IsEmpty()) hm->GetDat(PgpButtonsHdr);
   int i=0; while((cmd=GetToken(i++,hdr,";"))!="")
      cmds->Add(cmd.Trim());
   ids = cmds->Values["sign"];
   keyid = GetToken(0,ids,",");
   passphrase = Passphrase->Get(keyid);
   delete cmds;
   delete hm;
   return !keyid.IsEmpty();
}
//---------------------------------------------------------------------------
/*void __fastcall AddNymMailLine(TStrings *msg)       // obsolete
{
   for (int i=0; i<msg->Count; i++)
   {
      if (msg->Strings[i].Trim().IsEmpty())
      {
         msg->Strings[i] = "NYMSERVER MESSAGE=================";
         break;
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall RemoveNymMailLine(TStrings *msg)
{
   for (int i=0; i<msg->Count; i++)
   {
      if (msg->Strings[i].Trim().IsEmpty()) break;
      if (msg->Strings[i]=="NYMSERVER MESSAGE=================")
          msg->Strings[i] = "";
   }
}*/
//---------------------------------------------------------------------------
bool __fastcall PgpIsConventional(char *Message)
{
   TPgpMsg *pgpmsg = new TPgpMsg(Message);
   bool is = pgpmsg->IsConventional();
   delete pgpmsg;
   return is;
}
//---------------------------------------------------------------------------
bool __fastcall GoodKeys(TStrings *keylist)
{
   bool good = false;
   for (int i=0; i<keylist->Count; i++)
      if (keylist->Strings[i].Pos("0x")>1)
      {
         good = true;
         break;
      }
   return good;
}
//---------------------------------------------------------------------------
//bool __fastcall PgpImportKeys(TForm *Owner, TPGPbuffer *ImpKeys, char* ImportDir)
//{
//   return ImportPGPKeys(Owner,ImpKeys,AnsiString(ImportDir));
//}
//---------------------------------------------------------------------------
//bool  __fastcall PgpExportKeys(TForm *Owner, TPGPbuffer *PublicKeys,
//   TPGPbuffer *SecretKeys, char *SelectedKeyId, char *ExportDir)
//{
//   return ExportOpenPGPKeys(Owner, PublicKeys, SecretKeys, AnsiString(SelectedKeyId),
//      AnsiString(ExportDir));
//}
//---------------------------------------------------------------------------

char* __fastcall PgpEncryptMessage(char *Message)
{
   TStringList *msg = new TStringList(); msg->SetText(Message);
   if (retbuf) delete retbuf; retbuf = NULL;

   CutMessageAtCutmarks(msg);
   if (!msg->Count)
   {
      MsgBoxHwnd(ActMainForm->Handle,
         s("Your message appears empty! Nothing to encrypt!"),
        "QS PGP Encrypt Error",
         MB_OK
      );
      delete msg;
      return NULL;
   }
   int idx=0; while (idx < msg->Count && !msg->Strings[idx].Trim().IsEmpty())
       idx++;

   if (idx == msg->Count)// || !msg->Strings[idx].TrimRight().IsEmpty())
   {
      MsgBoxHwnd(ActMainForm->Handle,
         s("Your message does not appear to have a body--or maybe\n")+
         s("there is not an empty line between headers and body\n\n")+
         s("Nothing to encrypt!"),
         "QS Encrypt Error",MB_OK);
      delete msg;
      return NULL;
   }

   // remove headers and hold for later
   TStringList *mail = new TStringList();
   while (msg->Count>idx+1)
   {
      mail->Add(msg->Strings[idx+1]);
      msg->Delete(idx+1);
   }
   if (!mail->Count)
   {
      MsgBoxHwnd(ActMainForm->Handle,
         s("Your message appears empty! Nothing to encrypt!"),
        "QS Encrypt Error",
         MB_OK
      );
      delete mail;
      delete msg;
      return NULL;
   }

   TStringList *recips = new TStringList();
   AnsiString passphrase, keyid, keyiderr, sigid;
   GetEncryptKeyidsFromPgpHdr(msg, recips, keyiderr);
   if (!keyiderr.IsEmpty())
   {
      MsgBoxHwnd(ActMainForm->Handle,
         "The key "+keyiderr+" is not among your public PGP keys!",
         "ERROR",
          MB_OK
      );
      delete recips;
      delete mail;
      delete msg;
      return NULL;
   }

   bool needids = recips->Count==0;
   THeaderManager *Headers = new THeaderManager(msg);
   if (needids) Headers->GetRecipsFull("To: ",recips,msg);
   delete Headers;

   if (needids && !PGPgetEncryptList(recips))
   {
      delete recips;
      delete mail;
      delete msg;
      return NULL;
   }

   bool cEncrypt = recips->Text == UseConventional + "\r\n";
   if (cEncrypt && !PGPGETConventionalPassphrase(ActMainForm, passphrase))
   {
      ClearString(passphrase);
      delete recips;
      delete mail;
      delete msg;
      return NULL;
   }

   if (HasSdk())
   {
      bool ok;
      if (cEncrypt) ok = PGPsdk->CEncryptMessage(mail, passphrase.c_str());
      else ok = PGPsdk->EncryptMessage(mail, recips);
      if (!ok)
      {
         ClearString(passphrase);
         delete recips;
         delete msg;
         return NULL;
      }
      msg->AddStrings(mail);
      retbuf = new char[msg->Text.Length() + 1];

      strcpy(retbuf, msg->Text.c_str());
      ClearString(passphrase);
      delete recips;
      delete mail;
      delete msg;
      return retbuf;
   }

   int result;
   TPgpDlg *Pgp = new TPgpDlg(PgpPublicRing(),PgpSecretRing(),PgpRemailRing(),ActMainForm);
   if (cEncrypt) result = Pgp->EncryptCMessage(mail,passphrase);
   else result = Pgp->EncryptMessage(mail,recips);
   delete Pgp;

   if (result==PGP_OK)
   {
      msg->AddStrings(mail); mail->Clear();
      if ((retbuf=new char[msg->Text.Length()+1])!=NULL)
         strcpy(retbuf,msg->Text.c_str());
   }

   ClearString(passphrase);
   delete recips;
   delete mail;
   delete msg;
   return retbuf;
}
//---------------------------------------------------------------------------
char* __fastcall PgpEncryptSignMessage(char *Message)
{
   TStringList *msg = new TStringList(); msg->SetText(Message);
   if (retbuf) delete retbuf; retbuf = NULL;

   TStringList *recips = new TStringList();
   AnsiString passphrase,keyid,keyiderr,sigid;
   GetEncryptKeyidsFromPgpHdr(msg,recips,keyiderr);
   if (!keyiderr.IsEmpty())
   {
         MsgBoxHwnd(ActMainForm->Handle,
            "The key "+keyiderr+" is not among your public PGP keys!",
            "ERROR",
             MB_OK
         );
      delete recips;
      delete msg;
      return NULL;
   }

   bool needids = recips->Count==0;
   GetSignKeyidFromPgpHdr(msg,keyid,passphrase); sigid = keyid;
   THeaderManager *Headers = new THeaderManager(msg);
   if (keyid.IsEmpty()) keyid=Headers->GetDat("From: ");
   if (needids) Headers->GetRecipsFull("To: ",recips,msg);
   delete Headers;

   // get list of public keys
   if (needids && !PGPgetEncryptList(recips,NotConventional))
   {
      delete recips;
      delete msg;
      return NULL;
   }

   // open keyrings for signing key
   AnsiString idtext8;
   TPGPbuffer *key = new TPGPbuffer();
   TStringList *keys = new TStringList();
   TStringList *uids = new TStringList();
   TPGPbuffer *seckeys = new TPGPbuffer(PgpSecretRing());
   while (key->copykeyfrom(seckeys,REWIND))
   {
      if (SecretKeyPacket(key->CTB))
      {
         idtext8 = key->idtext8;
         key->getuserids(uids);
         for (int i=0; i<uids->Count; i++)
            keys->Add("0x"+idtext8+" "+uids->Strings[i]);
      }
      key->clear();
   }
   delete seckeys;
   delete uids;
   delete key;

   // fail job if no secret keys
   if (!keys->Count)
   {
      MsgBoxHwnd(ActMainForm->Handle,
         "No keys found!","QS PGP Error",MB_OK);
      delete recips;
      delete keys;
      delete msg;
      return NULL;
   }

   // pause
   Application->ProcessMessages(); Sleep(200);
   // keys ok, get sign key and passphrase
   int current=-1;
   for (int i=0; i<keys->Count; i++)
   {
      if (keys->Strings[i].Pos(keyid)>0)
      {
         if (keys->Strings[i].Pos("0x")==1)
            sigid = keys->Strings[i].SubString(1,10);
         current = i;
         break;
      }
   }
   if (current>=0 && passphrase.IsEmpty()) passphrase = Passphrase->Get(sigid);
   if (passphrase.IsEmpty() && // got passphrase from cache already ?
      !PGPGETSignKeyIDAndPassphrase(ActMainForm,keys,current,passphrase))
   {
      delete recips;
      delete keys;
      delete msg;
      return NULL;
   }
   if (current>=0 && current<keys->Count)
   {
      keyid = keys->Strings[current];
      sigid = keyid.SubString(1,10);
   }
   keyid = GetEAddress(keyid);

   // prepare message
   CutMessageAtCutmarks(msg);
   if (!msg->Count)
   {
      MsgBoxHwnd(ActMainForm->Handle,
         s("Your message appears empty! Nothing to sign!"),
        "QS PGP Encrypt Error",
         MB_OK
      );
      ClearString(passphrase);
      delete recips;
      delete keys;
      delete msg;
      return NULL;
   }
   int idx=0; while (idx<msg->Count && !msg->Strings[idx].TrimRight().IsEmpty())
       idx++;
   if (idx==msg->Count)
   {
      MsgBoxHwnd(ActMainForm->Handle,
         s("Your message does not appear to have a body--or maybe\n")+
         s("there is not an empty line between headers and body\n\n")+
         s("Nothing to encrypt!"),
         "QS PGP Encrypt Error",MB_OK);
      ClearString(passphrase);
      delete recips;
      delete keys;
      delete msg;
      return NULL;
   }
   TStringList *mail = new TStringList();
   while (msg->Count>idx+1)
   {
      mail->Add(msg->Strings[idx+1]);
      msg->Delete(idx+1);
   }
   if (!mail->Count)
   {
      MsgBoxHwnd(ActMainForm->Handle,
         s("Your message appears empty! Nothing to sign!"),
        "QS PGP Encrypt Error",
         MB_OK
      );

      ClearString(passphrase);
      delete recips;
      delete keys;
      delete msg;
      return NULL;
   }

   if (HasSdk())
   {
      //PGPError result;
      TStringList *Msg = new TStringList(); Msg->SetText(Message);
      if (!PGPsdk->EncryptSignMessage(Msg, recips, sigid.c_str(), passphrase.c_str()))
      {
         ClearString(passphrase);
         delete Msg;
         delete recips;
         delete keys;
         delete msg;
         return NULL;
      }

      if ((retbuf=new char[Msg->Text.Length()+1])!=NULL);
         strcpy(retbuf,Msg->Text.c_str());

      Passphrase->Add(sigid,passphrase);
      ClearString(passphrase);

      delete Msg;
      delete recips;
      delete keys;
      delete msg;
      return retbuf;
   }

   TPgpDlg *Pgp = new TPgpDlg(PgpPublicRing(),PgpSecretRing(),PgpRemailRing(),ActMainForm);
   int result = Pgp->EncryptSignMessage(mail,keyid,passphrase,recips,&sigid);

   if (result==PGP_OK)
   {
      msg->AddStrings(mail); mail->Clear();
      if ((retbuf=new char[msg->Text.Length()+1])!=NULL)
         strcpy(retbuf,msg->Text.c_str());

      Passphrase->Add(sigid,passphrase);
   }

   ClearString(passphrase);
   delete Pgp;

   delete mail;
   delete keys;
   delete recips;
   delete msg;
   return retbuf;
}
//---------------------------------------------------------------------------
bool __fastcall PgpIsClearSigned(char *Message)
{
   return strstr(Message,BeginPgpSignedMessage.c_str())!=NULL;
}
//---------------------------------------------------------------------------
char* __fastcall PgpSignMessage(char *Message)
{
   TStringList *msg = new TStringList(); msg->SetText(Message);
   if (retbuf) delete retbuf; retbuf = NULL;
   CutMessageAtCutmarks(msg);

   if (!msg->Count)
   {
      MsgBoxHwnd(ActMainForm->Handle,
         s("Your message appears empty! Nothing to sign!"),
        "QS PGP Encrypt Error",
         MB_OK
      );
      delete msg;
      return NULL;
   }

   int idx=0; while (idx<msg->Count && !msg->Strings[idx].Trim().IsEmpty())
       idx++;

   if (idx==msg->Count)
   {
      MsgBoxHwnd(ActMainForm->Handle,
         s("Your message does not appear to have a body--or maybe\n")+
         s("there is not an empty line between headers and body\n\n")+
         s("Nothing to sign!"),
        "QS PGP Encrypt Error",
         MB_OK
      );
      delete msg;
      return NULL;
   }

   AnsiString idtext8,sigid;
   TPGPbuffer *key = new TPGPbuffer();
   TStringList *keys = new TStringList();
   TStringList *uids = new TStringList();
   TPGPbuffer *seckeys = new TPGPbuffer(PgpSecretRing());
   while (key->copykeyfrom(seckeys,REWIND))
   {
      if (SecretKeyPacket(key->CTB))
      {
         idtext8 = key->idtext8;
         key->getuserids(uids);
         for (int i=0; i<uids->Count; i++)
            keys->Add("0x"+idtext8+" "+uids->Strings[i]);
      }
      key->clear();
   }
   delete seckeys;
   delete uids;
   delete key;

   if (!keys->Count)
   {
      MsgBoxHwnd(ActMainForm->Handle,
         "No keys found!","QS PGP Error",MB_OK);
      delete keys;
      delete msg;
      return NULL;
   }

   AnsiString passphrase,keyid;
   GetSignKeyidFromPgpHdr(msg,keyid,passphrase);
   sigid = keyid;

   THeaderManager *Headers = new THeaderManager(msg);
   if (keyid.IsEmpty()) keyid = Headers->GetDat("From: ");
   TStringList *recips = new TStringList();
   Headers->GetRecipsFull("To: ",recips);
   delete Headers;

   int current=-1;
   for (int i=0; i<keys->Count; i++)
   {
      if (keys->Strings[i].Pos(keyid)>0)
      {
         if (keys->Strings[i].Pos("0x")==1)
            sigid = keys->Strings[i].SubString(1,10);
         current = i;
         break;
      }
   }
   if (current>=0 && passphrase.IsEmpty())
      passphrase = Passphrase->Get(sigid);

getpass:

   if (passphrase.IsEmpty() && // maybe passphrase from cache?
      !PGPGETSignKeyIDAndPassphrase(ActMainForm, keys,current, passphrase))
   {
      delete recips;
      delete keys;
      delete msg;
      return NULL;
   }

   if (current>=0 && current<keys->Count)
   {
      keyid = keys->Strings[current].SubString(12,128);
      sigid = keys->Strings[current].SubString(3,8);
   }
   else
   {
      MsgBoxHwnd(ActMainForm->Handle,
         "No signing key selected.","PGP Error",MB_OK);
      delete recips;
      delete keys;
      delete msg;
      return NULL;
   }

   if (HasSdk())
   {
      bool ok = PGPsdk->SignMessage(msg, sigid.c_str(), passphrase.c_str());

      if (!ok && PGPsdk->err == kPGPError_BadPassphrase)
      {
         passphrase = "";
         goto getpass;
      }

      if (!ok)
      {
         ClearString(passphrase);
         delete recips;
         delete keys;
         delete msg;
         return NULL;
      }

      if ((retbuf = new char[msg->Text.Length() + 1]) != NULL)
         strcpy(retbuf, msg->Text.c_str());

      Passphrase->Add(sigid,passphrase);
      ClearString(passphrase);

      delete recips;
      delete keys;
      delete msg;
      return retbuf;
   }

   keyid = GetEAddress(keyid);
   TPgpDlg *Pgp = new TPgpDlg(PgpPublicRing(),PgpSecretRing(),PgpRemailRing(),ActMainForm);
   Pgp->ToRemailer = Pgp->IsRemailed(recips); // to test for remailer address // added sigid later for tmpsecring file
   int result = Pgp->SignMessage(msg,keyid,passphrase,&sigid);

   if (result == PGP_OK)
   {
      if ((retbuf=new char[msg->Text.Length()+1])!=NULL)
         strcpy(retbuf,msg->Text.c_str());
      Passphrase->Add(sigid,passphrase);
   }

   ClearString(passphrase);
   delete Pgp;

   delete recips;
   delete keys;
   delete msg;
   return retbuf;
}
//---------------------------------------------------------------------------
/*char* __fastcall PgpSignMessage(char *Message)
{
   TStringList *msg = new TStringList(); msg->SetText(Message);
   if (retbuf) delete retbuf; retbuf = NULL;
   CutMessageAtCutmarks(msg);

   if (!msg->Count)
   {
      MsgBoxHwnd(ActMainForm->Handle,
         s("Your message appears empty! Nothing to sign!"),
        "QS PGP Encrypt Error",
         MB_OK
      );
      delete msg;
      return NULL;
   }

   int idx=0; while(idx<msg->Count && !msg->Strings[idx].Trim().IsEmpty()) idx++;
   if (idx==msg->Count)
   {
      MsgBoxHwnd(ActMainForm->Handle,
         s("Your message does not appear to have a body--or maybe\n")+
         s("there is not an empty line between headers and body\n\n")+
         s("Nothing to sign!"),
        "QS PGP Encrypt Error",
         MB_OK
      );
      delete msg;
      return NULL;
   }

   AnsiString idtext8,sigid;
   TStringList *keys = new TStringList();
   TPGPbuffer *key = new TPGPbuffer();
   TStringList *uids = new TStringList();
   TPGPbuffer *seckeys = new TPGPbuffer(PgpSecretRing());
   while (key->copykeyfrom(seckeys,REWIND))
   {
      if (SecretKeyPacket(key->CTB))
      {
         idtext8 = key->idtext8;
         key->getuserids(uids);
         for (int i=0; i<uids->Count; i++)
            keys->Add("0x"+idtext8+" "+uids->Strings[i]);
      }
      key->clear();
   }
   delete seckeys;
   delete uids;
   delete key;

      MsgBoxHwnd(ActMainForm->Handle,
         "No keys found!","QS PGP Error",MB_OK);
      delete keys;
      delete msg;
      return NULL;
   }

   AnsiString passphrase,keyid,idtext8,sigid;
   GetSignKeyidFromPgpHdr(msg,keyid,passphrase);
   sigid = keyid;

   THeaderManager *Headers = new THeaderManager(msg);
   if (keyid.IsEmpty()) keyid = Headers->GetDat("From: ");
   TStringList *recips = new TStringList();
   Headers->GetRecipsFull("To: ",recips);
   delete Headers;

   int current=-1;
   for (int i=0; i<keys->Count; i++)
   {
      if (keys->Strings[i].Pos(keyid)>0)
      {
         if (keys->Strings[i].Pos("0x")==1)
            sigid = keys->Strings[i].SubString(1,10);
         current = i;
         break;
      }
   }

   if (current>=0 && passphrase.IsEmpty()) passphrase = Passphrase->Get(sigid);
getpass:
   if (passphrase.IsEmpty() && // maybe passphrase from cache?
      !PGPGETSignKeyIDAndPassphrase(ActMainForm,keys,current,passphrase))
   {
      delete recips;
      delete keys;
      delete msg;
      return NULL;
   }

   if (current>=0 && current<keys->Count)
   {
      keyid = keys->Strings[current].SubString(12,128);
      sigid = keys->Strings[current].SubString(3,8);
   }
   else
   {
      MsgBoxHwnd(ActMainForm->Handle,
         "No signing key selected.","PGP Error",MB_OK);
      delete recips;
      delete keys;
      delete msg;
      return NULL;
   }

   if (HasSdk())
   {
      TStringList *Msg = new TStringList();
      Msg->SetText(Message);
      PGPError err = PGPsdk->SignMessage(Msg,sigid.c_str(),passphrase.c_str());
      if (err==kPGPError_BadPassphrase)
      {
         passphrase = "";
         goto getpass;
      }
      if (PGPsdk->IsPgpError(err,"Failed to clearsign message."))
      {
         ClearString(passphrase);
         delete recips;
         delete keys;
         delete msg;
         return NULL;
      }
      if (IsntPGPError(err))
      {
         if ((retbuf=new char[Msg->Text.Length()+1])!=NULL)
            strcpy(retbuf,Msg->Text.c_str());
         Passphrase->Add(idtext8,passphrase);
      }
      ClearString(passphrase);
      delete Msg;
      delete msg;
      return retbuf;
   }

   keyid = GetEAddress(keyid);
   // there is no need to transfer body to separate list as
   // the pgp sign cleartext takes the whole message--headers and body
   // AddNymMailLine puts text line between head and body
   TPgpDlg *Pgp = new TPgpDlg(PgpPublicRing(),PgpSecretRing(),PgpRemailRing(),ActMainForm);
   Pgp->ToRemailer = Pgp->IsRemailed(recips); // to test for remailer address // added sigid later for tmpsecring file
   int result = Pgp->SignMessage(msg,keyid,passphrase,&sigid);
   delete Pgp;

   if (result==PGP_OK && (retbuf=new char[msg->Text.Length()+1])!=NULL)
   {
      Passphrase->Add(sigid,passphrase);
      strcpy(retbuf,msg->Text.c_str());
   }

   ClearString(passphrase);
   delete recips;
   delete keys;
   delete msg;
   return retbuf;
}*/
//---------------------------------------------------------------------------
char* __fastcall PgpDecryptVerifyMessage(char *Message, bool ForceDialog)
{
   TPgpMsg *msg = new TPgpMsg(Message);
   if (msg->IsConventional())
   {
      delete msg;
      return IsConventionalEncr.c_str();
   }

   AnsiString id8,uid,userid; // get key(s) for keyid of encrypt msg
   TStringList *id8s=new TStringList();
   TStringList *tmp=new TStringList();
   tmp->Text = msg->IdText8();
   for (int i=0; i<tmp->Count; i++)
      if (id8s->IndexOf(tmp->Strings[i])<0)
         id8s->Add(tmp->Strings[i]);
   delete tmp;
   TStringList *uids = new TStringList();
   TPGPbuffer *key = new TPGPbuffer();
   TPGPbuffer *pgpdb = new TPGPbuffer(PgpPublicRing());
   TStringList *subs = new TStringList();
   int idx;

   while (key->copykeyfrom(pgpdb,REWIND))
   {
      if (id8s->IndexOf(key->idtext8)>=0)
      {
         uid = key->firstuid+" 0x"+key->idtext8;
         if (uids->IndexOf(uid)<0)
            uids->Add(uid);
      }
      if ((idx=id8s->IndexOf(key->subidtext8))>=0)
      {
         uid = key->firstuid+" 0x"+key->idtext8;
         if (uids->IndexOf(uid)<0)
            uids->Add(uid);
         id8s->Strings[idx] = key->idtext8;
         subs->Add(key->subidtext8);
      }
      key->clear();
      key->fsubidtext8 = "";
   }
   for (int i=0; i<id8s->Count; i++)
   {
      id8 = id8s->Strings[i];
      if (!uids->Text.Pos("0x"+id8) && subs->IndexOf(id8)<0)
         uids->Add("0x"+id8);
   }
   delete key;
   bool clear = PgpIsClearSigned(Message);
   if (!clear && !GoodKeys(uids))
   {
      for (int i=0; i<id8s->Count; i++)
      {
         id8 = id8s->Strings[i];
         if (id8.Pos("0x")!=1) id8s->Strings[i] = "0x"+id8;
      }
      MsgBoxHwnd(ActMainForm->Handle,
         s("Sorry, you do not have a secret key corresponding to any\n")+//required to\n")+
         s("of the public keys below.\n\n"+id8s->Text),
         "Can't Decrypt",
         MB_OK);
      delete pgpdb;
      delete id8s;
      delete msg;
      return NULL;
   }
   delete pgpdb;
   AnsiString idtext8,passphrase=Passphrase->Get(id8s,idtext8);
getpass:
   if (!clear && (passphrase.IsEmpty() || ForceDialog) && !PGPGETSecretKeyPassphrase(ActMainForm,uids->Text,passphrase))
   {
      delete uids;
      delete id8s;
      delete msg;
      return NULL;
   }

   if (HasSdk())
   {
      TStringList *Msg = new TStringList();
      Msg->SetText(Message);

      bool ok = PGPsdk->DecryptMessage(Msg, passphrase.c_str(), id8s, true);
      if (!ok && PGPsdk->err == kPGPError_BadPassphrase)
      {
         passphrase = "";
         goto getpass;
      }

      if (!ok)
         return NULL;

      if ((retbuf = new char[Msg->Text.Length()+1])!=NULL)
         strcpy(retbuf,Msg->Text.c_str());

      Passphrase->Add(idtext8, passphrase);
      ClearString(passphrase);

      delete Msg;
      delete uids;
      delete id8s;
      delete msg;
      return retbuf;
   }

   int result=16; // just a non-error number
   if (msg->buf->length)
   {
      TPgpDlg *Pgp = new TPgpDlg(PgpPublicRing(),PgpSecretRing(),PgpRemailRing(),ActMainForm);
      result = Pgp->DecryptMessage(msg->buf,passphrase);
      delete Pgp;
   }
   else
      MsgBoxHwnd(ActMainForm->Handle,"Nothing to decrypt!","PGP Decrypt Error",MB_OK);
   if (result==PGP_OK || result==PGP_SIGOK || result==PGP_SIGBAD || result==PGP_SIGNKEY)
   {
      if ((retbuf=new char[msg->buf->length+1])!=NULL)
         strcpy(retbuf,(char*)msg->buf->data);
      Passphrase->Add(idtext8,passphrase);
      ClearString(passphrase);
   }
   delete uids;
   delete id8s;
   delete msg;
   return retbuf;
}
//---------------------------------------------------------------------------
/*char* __fastcall PgpDecryptVerifyMessage(char *Message, bool ForceDialog)
{
   TPgpDBKey *key;
   TPgpMsg *msg = new TPgpMsg(Message);
   if (msg->IsConventional())
   {
      delete msg;
      return IsConventionalEncr.c_str();
   }

   AnsiString userid; // get key(s) for keyid of encrypt msg
   TStringList *id8s=new TStringList();
   TStringList *tmp=new TStringList();
   tmp->Text = msg->IdText8();
   for (int i=0; i<tmp->Count; i++)
      if (id8s->IndexOf(tmp->Strings[i])<0)
         id8s->Add(tmp->Strings[i]);
   delete tmp;

   TStringList *uids = new TStringList();
   TPgpDB *pgpdb = new TPgpDB(PgpSecretRing());
   for (int i=0; i<pgpdb->KeyCount(); i++)
   {
      key = pgpdb->GetKey(i);
      if (id8s->IndexOf(key->IdText8())>=0)
         uids->Add(key->KeyUserIds(0)+" 0x"+key->IdText8());
   }
   for (int i=0; i<id8s->Count; i++)
      if (!uids->Text.Pos("0x"+id8s->Strings[i]))
         uids->Add("0x"+id8s->Strings[i]);

   bool clear = PgpIsClearSigned(Message);
   if (!clear && !GoodKeys(uids))
   {
      for (int i=0; i<id8s->Count; i++) id8s->Strings[i] = "0x"+id8s->Strings[i];
      MsgBoxHwnd(ActMainForm->Handle,
         s("Sorry, you do not have a secret key corresponding to any\n")+//required to\n")+
         s("of the public keys below.\n\n"+id8s->Text),
         "Can't Decrypt",
         MB_OK);
      delete pgpdb;
      delete id8s;
      delete msg;
      return NULL;
   }
   delete pgpdb;

   AnsiString idtext8,passphrase=Passphrase->Get(id8s,idtext8);
getpass:
   if (!clear && (passphrase.IsEmpty() || ForceDialog) && !PGPGETSecretKeyPassphrase(ActMainForm,uids->Text,passphrase))
   {
      delete uids;
      delete id8s;
      delete msg;
      return NULL;
   }

   if (HasSdk())
   {
      TStringList *Msg = new TStringList();
      Msg->SetText(Message);
      PGPError err = PGPsdk->DecryptMessage(Msg,passphrase.c_str(),true);
      if (err==kPGPError_BadPassphrase)
      {
         passphrase = "";
         goto getpass;
      }

      if (PGPsdk->IsPgpError(err,"Failed to decrypt/verify message."))
         return NULL;

      if ((retbuf=new char[Msg->Text.Length()+1])!=NULL)
         strcpy(retbuf,Msg->Text.c_str());
      Passphrase->Add(idtext8,passphrase);
      ClearString(passphrase);

      delete Msg;
      delete uids;
      delete id8s;
      delete msg;
      return retbuf;
   }

   int result=16; // just a non-error number
   if (msg->buf->length)
   {
      TPgpDlg *Pgp = new TPgpDlg(PgpPublicRing(),PgpSecretRing(),PgpRemailRing(),ActMainForm);
      result = Pgp->DecryptMessage(msg->buf,passphrase);
      delete Pgp;
   }
   else
      MsgBoxHwnd(ActMainForm->Handle,"Nothing to decrypt!","PGP Decrypt Error",MB_OK);
   if (result==PGP_OK || result==PGP_SIGOK || result==PGP_SIGBAD || result==PGP_SIGNKEY)
   {
      if ((retbuf=new char[msg->buf->length+1])!=NULL)
         strcpy(retbuf,(char*)msg->buf->data);
      Passphrase->Add(idtext8,passphrase);
      ClearString(passphrase);
   }
   delete uids;
   delete id8s;
   delete msg;
   return retbuf;
}*/
//---------------------------------------------------------------------------
char* __fastcall PgpVerifyMessage(char *Message)
{
   if (retbuf) delete retbuf; retbuf = NULL;
   if (HasSdk())
   {
      TStringList *msg = new TStringList();
      msg->SetText(Message);
      PGPsdk->VerifyClearSigned(msg);
      //PGPsdk->DecryptMessage(msg, "", NULL, false);
      retbuf = new char[msg->Text.Length()+1];
      strcpy(retbuf, msg->Text.c_str());
      delete msg;
      return retbuf;
   }
   return "";
}
//---------------------------------------------------------------------------
bool __fastcall PgpGetEncryptList(TForm *Owner, TStrings *Recips, bool CanConv)
{
   bool ok=false;
   TPgpRecipDlg *pf = new TPgpRecipDlg(Owner,Recips,CanConv);
   if (pf->opendlg) pf->ShowModal();
   if (pf->ModalResult==mrOk || !pf->opendlg)
      ok = true;
   delete pf;
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall PgpCheckPGP6NeedsUpdate()
{
   if (HasSdk())// && SdkApiVer()>=PGP600)
      return PGPsdk->CheckPGP6NeedsUpdate(PGPsdk->owner);
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall PgpUpdateQSKeyrings()
{
   if (HasSdk())  // && SdkApiVer()>=PGP600)
   {
      return PGPsdk->UpdateQSKeyrings(PGPsdk->owner);
   }
   return false;
}
//---------------------------------------------------------------------------
char* __fastcall PgpPubringPkr()
{
   if (retbuf) delete retbuf; retbuf = NULL;
   if (HasSdk())
   {
      retbuf = new char[PGPsdk->mainpubringpkr.Length() + 1];
      strcpy(retbuf, PGPsdk->mainpubringpkr.c_str());
      return retbuf;
   }
   return "";
}
//---------------------------------------------------------------------------
char* __fastcall PgpSecringSkr()
{
   if (retbuf) delete retbuf; retbuf = NULL;
   if (HasSdk())
   {
      retbuf = new char[PGPsdk->mainsecringskr.Length() + 1];
      strcpy(retbuf, PGPsdk->mainsecringskr.c_str());
      return retbuf;
   }
   return "";
}
//---------------------------------------------------------------------------
//void __fastcall PgpOpenPersonalKeyring()
//{
//   if (!PgpKeyWin) PgpKeyWin = new TPgpKeyWin(ActMainForm,PgpPublicRing(),PgpSecretRing());
//   else PgpKeyWin->BringToFront();
//}
//---------------------------------------------------------------------------
char* __fastcall PgpPath()
{
   if (retbuf) delete retbuf; retbuf = NULL;
   AnsiString pgppath = PGPpath(ActMainForm);
   retbuf = new char[pgppath.Length()+1];
   strcpy(retbuf,pgppath.c_str());
   return retbuf;
}
//---------------------------------------------------------------------------














